<template lang="pug">
	article.listado
		ul( v-if="archivos.length" )
			li( v-for="item in archivos", @click="obtener(item.id)", :data-id="item.id" )
				.archivo
					figure( v-if="item.miniatura" ): img( :src="item.miniatura" )
					IconoFichero( v-else, :ext="item.tipo")
					p {{ item.nombre }}.{{ item.tipo }}
				//-.info
					img(src="~@img/ico-usuario.svg", alt="alt")
					p {{ item.propietario }}
				.acciones
					button( type="button", @click.stop="compartir(item.id)", v-tooltip="'Compartir'"  ).compartir
						vector(src="~@img/ico-compartir.svg?inline")
					button( type="button", @click.stop="borrar(item.id)",v-tooltip="'Eliminiar'" ).eliminar: vector( src="~@img/ico-borrar.svg?inline")
					button.favorito(
						type="button"
						@click.stop="marcar( item.id )"
						:class="{ marcado: esFavorito( item.id )}"
						v-tooltip="'Favorito'"
						)
						vector( src="@img/ico-favorito.svg?inline")
					button( type="button", @click.stop="descargar(item.id)", v-tooltip="'Descargar'" ).descargar: vector( src="@img/ico-descargar.svg?inline")
					button( type="button", :disabled="!tienePrevio( item.tipo )", v-tooltip="'Previsualizar'", @click.stop="ver( item )" ).ver: vector( src="@img/ico-ver.svg?inline")
					//-button( type="button" ).compartir: vector( src="@img/ico-compartir.svg?inline")

		h3( v-else ) No se encontraron resultados
		//-CajaLux( :visible="cajaActiva" )
			img( src="https://banner2.kisspng.com/20180508/slw/kisspng-kira-kosarin-the-thundermans-female-poster-nickelo-5af126d4ab04a9.2220748015257535567005.jpg", alt="alt")

		modal.previo(
			name="previoListado",
			:max-width="640",
			:max-height="640",
			:adaptive="true",
			width="80%",
			height="90%"
			)
			button.cerrar(
				type="button",
				@click="$modal.hide('previoListado')" ) &times;

			//-iframe( v-if="archivo", :src="previo( archivo.id )" )
			figure( v-if="archivo && esImagen(archivo.tipo)" )
				img( :src="previo( archivo.id )", :alt="archivo.descripcion")
			video( v-if="archivo && esVideo(archivo.tipo)", "controls", "autoplay" )
				source( :src="previo( archivo.id )", :type="'video/'+archivo.tipo")

	//-table
		thead: tr
			th.archivo Archivo
			th.usuario Usuario
			th.acciones Acciones
		tbody
			tr( v-for="item in lista" )
				td.archivo: .info
					icono(:ext="item.ext").min
					p {{ item.nombre}}
				td.usuario: .info
					p {{ item.propietario }}

				td.acciones
					button( type="button" ).eliminar: vector( src="~@img/ico-borrar.svg?inline")
					button( type="button" ).favorito: vector( src="@img/ico-favorito.svg?inline")
					button( type="button" ).descargar: vector( src="@img/ico-descargar.svg?inline")
					button( type="button" ).ver: vector( src="@img/ico-ver.svg?inline")
					button( type="button" ).compartir: vector( src="@img/ico-compartir.svg?inline")
					//- button( type="button" ) descargar
					//- button( type="button" ) ver
					//- button( type="button" ) compartir

</template>

<script>
	import IconoFichero from "@/components/IconoFichero";
	import { archivos } from "@/api";
	import { mapState, mapActions, mapGetters } from "vuex";

	const W = window;

	export default {
		name: "Listado",
		components: {
			IconoFichero
		},
		data() {
			return {
				cajaActiva: true,
				lista: [],
				archivo: null
			};
		},
		computed: {
			...mapState(["archivos"]),
			...mapGetters(["esFavorito", "previo"])
		},
		methods: {
			esImagen(tipo) {
				const imagenes = [
					"jpg",
					"png",
					"webp",
					"gif",
					"psd",
					"pdf",
					"tiff",
					"zip"
				];
				return imagenes.includes(tipo.toLowerCase());
			},
			esVideo(tipo) {
				const videos = ["mp4"];
				return videos.includes(tipo.toLowerCase());
			},
			esArchivo(tipo) {
				const archivos = ["pdf"];
				return archivos.includes(tipo.toLowerCase());
			},
			tienePrevio(tipo) {
				return (
					this.esImagen(tipo) ||
					this.esVideo(tipo) ||
					this.esArchivo(tipo)
				);
			},
			obtener(id) {
				this.obtenerArchivo({ id });
				//document.querySelector("main").scrollTo(0, 0);
				//this.$modal.show(id);
			},
			compartir(id) {
				this.$root.$emit("archivo-compartir", id);
			},
			borrar(id) {
				const pregunta =
					"Eliminar Archivo.\nEsta acción eliminará el archivo .";
				let confirmacion = confirm(pregunta);
				if (confirmacion) {
					this.borrarArchivo({ id });
					this.$root.$emit("archivo-actualizado");
				}
			},
			marcar(id) {
				this.marcarArchivo({ id, marcar: !this.esFavorito(id) });
			},
			ver(archivo) {
				this.archivo = archivo;
				this.$modal.show("previoListado");
			},
			descargar(id) {
				archivos.descargar(id);
			},
			...mapActions(["marcarArchivo", "obtenerArchivo", "borrarArchivo"])
		},
		mounted() {
			//console.log( "dialogo" );
			//this.$modal.show('previo');
			this.$root.$on("archivo-actualizado", () => {
				let imgs = this.$el.querySelectorAll("img");
				console.log(imgs);
				imgs.forEach(img => {
					let src = img.src;
					img.src = "";
					img.src = src;
				});
			});

			this.$root.$on("archivo-previo", archivo => {
				this.archivo = archivo;
				this.$modal.show("previoListado");
			});
		}
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	.listado
		li
			display flex
			align-items center
			justify-content space-between
			padding .5rem .5rem
			border-bottom 1px solid lighten( gris, 50% )
			cursor pointer

			&:hover
				background-color gris_super_claro

		h3
			padding 1rem
			font-size calcRem( 14 )
			color lighten( gris, 50% )

		p
			color lighten( negro, 40% )
			font-size calcRem( 12 )

		.archivo
			flex 2 1 40%
			display flex
			align-items center

			> *
				margin 0 .5rem

			.iconoFichero
				width 24px
				margin-right .5rem

			figure
				width 24px
				height 24px
				display grid

				img
					width 100%
					height 100%
					object-fit cover

		.info
			flex 2 1 30%
			display flex
			align-items center

			> *
				margin 0 .5rem

			img
				width 15px

		.acciones
			flex 0 1 auto
			display flex
			justify-content space-between

			button
				flex 0 0 32px
				border none
				width 32px
				height 32px
				border-radius 1rem
				display flex
				align-items center
				justify-content center
				padding 0
				margin 0 .1rem
				cursor pointer
				color tint( azul, 40% )
				background-color transparente

				&[disabled]
					opacity .5
					color gris

				&:hover
					background-color tint( azul, 90% )

				.vector
					height 20px

					svg
						display block

				&.marcado
					background-color tint( azul, 50% )
					color blanco

			.eliminar
				color tint( rojo, 40% )

	.previo
		.cerrar
			absolute top right
			padding .2rem .4rem
			color tint( azul, 40% )
			background-color blanco
			font-size 1.5rem
			cursor pointer
			font-weight bold
			z-index 1

		video
			absolute top left right bottom
			width 100%
			height 100%
			background-repeat no-repeat
			background-size 32px
			background-position center
			background-image url( "/img/cargando.gif" )
			background-color #FFF

		figure
			absolute top left right bottom
			display flex
			align-items center
			z-index 0
			background-repeat no-repeat
			background-size 32px
			background-position center
			background-image url( "/img/cargando.gif" )
			background-color #FFF

			img
				max-width 100%
				max-height 100%
</style>
